osgTerrain::TerrainTechnique Class Reference

`#include <TerrainTechnique>`

Inheritance diagram for osgTerrain::TerrainTechnique:

## Public Member Functions

| TerrainTechnique ()
| TerrainTechnique (const TerrainTechnique &, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgTerrain, TerrainTechnique)
virtual void | setTerrainTile (TerrainTile *tile)
TerrainTile * | getTerrainTile ()
const TerrainTile * | getTerrainTile () const
virtual void | init (int dirtyMask, bool assumeMultiThreaded)
virtual void | update (osgUtil::UpdateVisitor *nv)
virtual void | cull (osgUtil::CullVisitor *nv)
virtual void | cleanSceneGraph ()
virtual void | traverse (osg::NodeVisitor &nv)
virtual void | releaseGLObjects (osg::State *=0) const
virtual void | addNeighbour (TerrainTile *tile)
virtual void | removeNeighbour (TerrainTile *tile)
virtual bool | containsNeighbour (TerrainTile *tile)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::Observer
| Observer ()
virtual | ~Observer ()
virtual void | objectDeleted (void *)

## Protected Member Functions

virtual | ~TerrainTechnique ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

TerrainTile * | _terrainTile
TerrainNeighbours | _neighbours
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Friends

class | osgTerrain::TerrainTile

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## TerrainTechnique() [1/2]

osgTerrain::TerrainTechnique::TerrainTechnique | ( |  | ) |

Referenced by META_Object(), and TerrainTechnique().

## TerrainTechnique() [2/2]

osgTerrain::TerrainTechnique::TerrainTechnique | ( | const TerrainTechnique & | ,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References osg::CopyOp::SHALLOW_COPY, and TerrainTechnique().

## ~TerrainTechnique()

virtual osgTerrain::TerrainTechnique::~TerrainTechnique | ( |  | ) |

protected virtual

## Member Function Documentation

## addNeighbour()

virtual void osgTerrain::TerrainTechnique::addNeighbour | ( | TerrainTile * | tile | ) |

inline virtual

References _neighbours, and osgTerrain::TerrainTile.

## cleanSceneGraph()

virtual void osgTerrain::TerrainTechnique::cleanSceneGraph | ( |  | ) |

virtual

Clean scene graph from any terrain technique specific nodes.

Reimplemented in osgTerrain::DisplacementMappingTechnique, and osgTerrain::GeometryTechnique.

## containsNeighbour()

virtual bool osgTerrain::TerrainTechnique::containsNeighbour | ( | TerrainTile * | tile | ) |

inline virtual

References _neighbours, and osgTerrain::TerrainTile.

## cull()

virtual void osgTerrain::TerrainTechnique::cull | ( | osgUtil::CullVisitor * | nv | ) |

virtual

Reimplemented in osgTerrain::DisplacementMappingTechnique, and osgTerrain::GeometryTechnique.

## getTerrainTile() [1/2]

TerrainTile * osgTerrain::TerrainTechnique::getTerrainTile | ( |  | ) |

inline

References _terrainTile, and osgTerrain::TerrainTile.

## getTerrainTile() [2/2]

const TerrainTile * osgTerrain::TerrainTechnique::getTerrainTile | ( |  | ) | const

inline

References _terrainTile, and osgTerrain::TerrainTile.

## init()

virtual void osgTerrain::TerrainTechnique::init | ( | int | dirtyMask,
|  | bool | assumeMultiThreaded )

virtual

Reimplemented in osgTerrain::DisplacementMappingTechnique, and osgTerrain::GeometryTechnique.

## META_Object()

osgTerrain::TerrainTechnique::META_Object | ( | osgTerrain | ,
|  | TerrainTechnique | )

References TerrainTechnique().

## releaseGLObjects()

virtual void osgTerrain::TerrainTechnique::releaseGLObjects | ( | osg::State * | = 0 | ) | const

inline virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Object.

Reimplemented in osgTerrain::DisplacementMappingTechnique, and osgTerrain::GeometryTechnique.

## removeNeighbour()

virtual void osgTerrain::TerrainTechnique::removeNeighbour | ( | TerrainTile * | tile | ) |

inline virtual

References _neighbours, and osgTerrain::TerrainTile.

## setTerrainTile()

virtual void osgTerrain::TerrainTechnique::setTerrainTile | ( | TerrainTile * | tile | ) |

virtual

References osgTerrain::TerrainTile.

## traverse()

virtual void osgTerrain::TerrainTechnique::traverse | ( | osg::NodeVisitor & | nv | ) |

virtual

Traverse the terrain subgraph.

Reimplemented in osgTerrain::DisplacementMappingTechnique, and osgTerrain::GeometryTechnique.

## update()

virtual void osgTerrain::TerrainTechnique::update | ( | osgUtil::UpdateVisitor * | nv | ) |

virtual

Reimplemented in osgTerrain::DisplacementMappingTechnique, and osgTerrain::GeometryTechnique.

## Friends And Related Symbol Documentation

## osgTerrain::TerrainTile

friend class osgTerrain::TerrainTile

friend

Referenced by addNeighbour(), containsNeighbour(), getTerrainTile(), getTerrainTile(), removeNeighbour(), and setTerrainTile().

## Member Data Documentation

## _neighbours

TerrainNeighbours osgTerrain::TerrainTechnique::_neighbours

protected

Referenced by addNeighbour(), containsNeighbour(), and removeNeighbour().

## _terrainTile

TerrainTile* osgTerrain::TerrainTechnique::_terrainTile

protected

Referenced by getTerrainTile(), and getTerrainTile().

The documentation for this class was generated from the following file:

- TerrainTechnique